import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/widgets/written_indicative_study_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5',
  'pron6',
];

const String _randomInfinitive = 'infinitive';

main() {
  testWidgets('Tightly coupled test of the next person button behaviour',
      (WidgetTester tester) async {
    VerbTestModel model = VerbTestModel();
    model.initialise(_randomIndicative, _randomPronouns, 'fr',
        _randomInfinitive, 'translation');
    const int defaultPerson = 0;
    await tester.pumpWidget(ChangeNotifierProvider(
        create: (BuildContext context) {
          return model;
        },
        child: const MaterialApp(
          home: WrittenIndicativeStudyWidget(),
        )));
    for (int i = 0; i < _randomPronouns.length; i++) {
      Finder pronounFinder = find.text(_randomPronouns[i]);
      expect(pronounFinder, findsNWidgets(2));
      Finder nextPersonButtonFinder = find.byKey(const Key('nextPersonKey'));
      expect(nextPersonButtonFinder, findsOneWidget);
      await tester.tap(nextPersonButtonFinder);
      await tester.pumpAndSettle();
    }
  });
}
